dofile( "data/scripts/lib/utilities.lua" )
if not async then
    dofile( "data/scripts/lib/coroutines.lua" )
end

async(function()
    local entity_id = GetUpdatedEntityID()

    wait(Random(30,100))
    jigglebox(entity_id)

    wait(Random(30,100))
    jigglebox(entity_id)

    wait(Random(30,100))
    jigglebox(entity_id)

    wait(Random(30,100))
    jigglebox(entity_id)

    wait(Random(30,100))
    jigglebox(entity_id)

    wait(Random(30,100))

    local x, y = EntityGetTransform( entity_id )

    local components = EntityGetComponent( entity_id, "VariableStorageComponent" )

    for i,comp_id in ipairs(components) do 
        local var_name = ComponentGetValue( comp_id, "name" )
		if( var_name == "oldpath") then
            local load_me = ComponentGetValue( comp_id, "value_string" )
			EntityLoad( load_me, x, y )
		end
		
	end
    
    EntityKill(entity_id)
    EntityLoad("data/entities/particles/image_emitters/transmutation_effect.xml", x, y)
    
end)

function jigglebox(entity_id)
    local dir_x = Random(-1, 1)
    local dir_y = Random(-1, 1)

    local len = math.sqrt((dir_x ^ 2)+(dir_y ^ 2))
    dir_x = dir_x / len
    dir_y = dir_y / len

    PhysicsApplyForce(entity_id, dir_x * 250, dir_y * 250)
end